function OnHTMLDataGridRowSelect(rowData, rowNumber) {}
function OnHTMLDataGridDataChange() {}

function escapeArray ( valArray )
{
	var valueList = new Array();

   for ( n = 0; n < valArray.length; n++ )
   {
      valueList[n] = escape(valArray[n]);
   }

   return valueList;
}

function HTMLDataGrid(controlVariable, frameDiv, initialData)
{
    //  Standard stuff
    this.ctrlVar = controlVariable;
    this.container = frameDiv;
    this.objHTML = buildTable;
    this.writeObjHTML = writeTable;

    //  Display Properties
	 this.headingData = new Array();
    this.arrayData = (initialData) ? initialData : new Array();
	 this.rowHeight = 30;
    this.bShowHeading = false;
    this.bNamedFirstColumn = false;
    this.bNumberRows = true;
	 this.border = 1;

	 // State Properties
	 this.maxRows = 1;
	 this.pages = 1;
	 this.currentPage = 0;
	 this.currentRow = new Array();

    // Methods
    this.addRow = addDataRow;
	 this.editRow = editDataRow;
    this.updateRow = updateDataRow;
    this.deleteRow = deleteDataRow;
    this.addHeading = addHeadingRow;
	 this.nextPage = nextDataPage;
	 this.prevPage = prevDataPage;

	 function writeTable()
	 {
  		document.all[this.container].innerHTML = this.objHTML();
	 }

    function buildTable()
    {
		 //this.maxRows = Math.floor(document.all[this.container].offsetHeight/this.rowHeight);
		 this.pages = Math.ceil(this.arrayData.length / this.maxRows);
		 
		 this.currentPage = Math.max(this.currentPage, 0);
		 this.currentPage = Math.min(this.currentPage, this.pages-1);

		 var numRows = (this.currentPage != this.pages-1) ? this.maxRows :
								         this.arrayData.length % this.maxRows;

		 var tableHTML = new String("<TABLE id=gridTable border=" + this.border + ">");
      
		 if (this.bShowHeading)
		 {
			tableHTML += "<tr>";
			if (this.bNumberRows) tableHTML += "<th>#</th>";
			for (i2 = 0; i2 < this.headingData.length; i2++)
			{
				 tableHTML += "<th>" + this.headingData[i2] + "</th>";
			}
			tableHTML += "</tr>";
		 }
		 
		 if (this.currentRow.length > 0)
		 {
			tableHTML += "<tr>";
			if (this.bNumberRows) tableHTML += "<td>" + this.currentRow[0] + "</td>";
			for (i2 = 1; i2 < this.currentRow.length; i2++)
			{
				 tableHTML += "<td>" + this.currentRow[i2] + "</td>";
			}
			tableHTML += "</tr>";
		 }
		 
		 for (i = this.maxRows*this.currentPage; i < this.maxRows*this.currentPage+numRows; i++)
       {
			 tableHTML += "<tr onclick=\"OnHTMLDataGridRowSelect('" + escapeArray(this.arrayData[i]) + "'," + i + ");\">";
			 if (this.bNumberRows) tableHTML += "<td>" + i + "</td>";

          for (i2 = 0; i2 < this.arrayData[i].length; i2++)
          {
             tableHTML += "<td>" + this.arrayData[i][i2] + "</td>";
          }

			 tableHTML += "</tr>";
       }

		 return tableHTML + "</table>";
    }

    function addDataRow(arRow) 
	 {
  		this.arrayData[this.arrayData.length] = arRow;
		OnHTMLDataGridDataChange();
	 }

	 function editDataRow(rowData, rowNumber)
	 {
       this.currentRow = new Array();

		 arData = rowData.split(",");  
		 this.currentRow[0] = rowNumber;

		 for (x2=0; x2 < arData.length; x2++) 
		 {
          this.currentRow[x2+1] = "<input id=currentRow" + x2 + " value=\"" + unescape(arData[x2]) + "\">";
		 }
		 

       this.currentRow[this.currentRow.length] = "<input type=button id=btnRow value='Update' onclick='" 
			                        + this.ctrlVar + ".updateRow(" + rowNumber + ")'>";
       
       OnHTMLDataGridDataChange();
	 }

    function updateDataRow(rowNumber, arRow) 
	 {
		 if (arguments.length == 1) 
		 {
			 arRow = new Array();
			 var eCount = 0;
  			
			 while (document.all["currentRow" + eCount]) 
			 {
				arRow[eCount] = document.all["currentRow" + eCount].value;
				eCount++;
			 }

			 this.currentRow = new Array();
		 }

		 this.arrayData[rowNumber] = arRow;
		 OnHTMLDataGridDataChange();
	 }

    function deleteDataRow(rowNumber) {}

    function addHeadingRow(arRow) 
	 { 
		 this.bShowHeading = true; 
		this.headingData = arRow;		
	 }

	 function nextDataPage(z)
	 {
		this.currentPage = (arguments.length == 1) ? z : ++this.currentPage;
		OnHTMLDataGridDataChange();
	 }
	 
	 function prevDataPage(z)
	 {
		 this.currentPage = (arguments.length == 1) ? z : --this.currentPage;
		 OnHTMLDataGridDataChange();
	 }
}
